package org.apache.bcel.util;

import java.util.HashMap;
import java.util.function.Function;
import java.util.Map;

public class SyntheticRepository extends MemorySensitiveClassPathRepository
{
    private static final Map<ClassPath, SyntheticRepository> MAP;
    
    public static SyntheticRepository getInstance() {
        return getInstance(ClassPath.SYSTEM_CLASS_PATH);
    }
    
    public static SyntheticRepository getInstance(final ClassPath classPath) {
        return SyntheticRepository.MAP.computeIfAbsent(classPath, SyntheticRepository::new);
    }
    
    private SyntheticRepository(final ClassPath path) {
        super(path);
    }
    
    static {
        MAP = new HashMap<ClassPath, SyntheticRepository>();
    }
}
